.enforce-coverage-awk: |
  function file_exists(file) {
      if ((getline _ < file) >= 0) {
          return 1;
      } else {
          return 0;
      }
  }

  function is_in_allowlist(filename, command, source_file, status) {
    if (!file_exists(".coverage-allowlist.txt")) {
      return 0;
    }
    command = "grep -F " filename " .coverage-allowlist.txt";
    command |& getline source_file;
    status = close(command);
    return status == 0;
  }

  BEGIN {
      EXIT_STATUS = 0
      COLOR_OFF = "\033[0m";
      COLOR_RED = "\033[0;31m";
      COLOR_GREEN = "\033[0;32m";
      COLOR_YELLOW = "\033[0;33m";
      COLOR_BLUE = "\033[0;34m";

      # declare an array called messages
      delete messages[0]
      m = 0;
  }

  {
      filename = $$1;
      status = $$10;
      color = "";

      if (filename !~ /.*\.rs/) {
          color = "";
      } else if (status == "100.00%") {
          if (is_in_allowlist(filename)) {
              color = COLOR_YELLOW;
              messages[m++] = "File '" filename "' is in allowlist but has 100% coverage, remove it from the list.";
              EXIT_STATUS = 1;
          } else {
              color = COLOR_GREEN;
          }
      } else {
          if (is_in_allowlist(filename)) {
              color =  COLOR_BLUE;
          } else {
              color = COLOR_RED;
              EXIT_STATUS = 1;
          }
      }

      print color $$0 COLOR_OFF;
  }

  END {
      for (idx in messages) {
          print COLOR_YELLOW messages[idx] COLOR_OFF;
      }
      exit EXIT_STATUS;
  }
